<template>
	<view class="uni-stat__select" >
		<span v-if="label" class="uni-label-text hide-on-phone">{{label + '：'}}</span>
		<view class="uni-select">
			<view class="uni-select__input-box" @click.stop="toggleSelector" >
				<view v-if="current" class="uni-select__input-text">{{current}}</view>
				<view v-else class="uni-select__input-text uni-select__input-placeholder">{{typePlaceholder}}</view>
				
				<uni-icons v-if="current && clear" type="clear" color="#1F242A" size="20" @click="clearVal" />
				<uni-icons v-else :type="showSelector? 'top' : 'bottom'" size="18" color="#1F242A" />
			</view>
			<!-- <view class="uni-select--mask" v-if="showSelector" @click="toggleSelector" /> -->
			<view class="uni-select__selector" v-if="showSelector">
				<view class="uni-popper__arrow"></view>
				<scroll-view scroll-y="true" class="uni-select__selector-scroll">
					<view class="addplus" v-if="showas" @click.stop="moveAdd" >
						+
					</view>
					<view class="searchbox" v-if="searchboxshow">
						<uni-icons type="search" color="rgb(246,185,78)" size="20"></uni-icons>
						<input type="text" v-model="seachcontent" :placeholder="plname" confirm-type="search" @input="changeSeach"/>
					</view>
					<view class="uni-select__selector-empty" v-if="mixinDatacomResData.length === 0">
						<text>{{emptyTips}}</text>
					</view>
					<view v-else class="uni-select__selector-item" v-for="(item,index) in mixinDatacomResData"
						:key="index" @click.stop="change(item)">
						<text :class="{'uni-select__selector__disabled': item.disable}">{{formatItemName(item)}}</text>
					</view>
				</scroll-view>
			</view>
		</view>
	</view>
</template>

<script>
	/**
	 * DataChecklist 数据选择器
	 * @description 通过数据渲染的下拉框组件
	 * @tutorial https://uniapp.dcloud.io/component/uniui/uni-data-select
	 * @property {String} value 默认值
	 * @property {Array} localdata 本地数据 ，格式 [{text:'',value:''}]
	 * @property {Boolean} clear 是否可以清空已选项
	 * @property {Boolean} emptyText 没有数据时显示的文字 ，本地数据无效
	 * @property {String} label 左侧标题
	 * @property {String} placeholder 输入框的提示文字
	 * @event {Function} change  选中发生变化触发
	 */

	export default {
		name: "uni-stat-select",
		mixins: [uniCloud.mixinDatacom || {}],
		data() {
			return {
				showSelector: false,
				current: '',
				mixinDatacomResData: [],
				apps: [],
				channels: [],
				seachcontent:'',
				pageIndex:1
			};
		},
		props: {
			localdata: {
				type: Array,
				default () {
					return []
				}
			},
			plname:{
				type: [String, Number],
				default: ''
			},
			showas:{
				type: Boolean,
				default: true
			},
			searchboxshow:{
				type: Boolean,
				default: true
			},
			nomore:{
				type: Boolean,
				default: true
			},
			value: {
				type: [String, Number],
				default: ''
			},
			modelValue: {
				type: [String, Number],
				default: ''
			},
			label: {
				type: String,
				default: ''
			},
			placeholder: {
				type: String,
				default: '请选择'
			},
			checklistIn: {
				type: Number,
				default: 0
			},
			emptyTips: {
				type: String,
				default: '无选项'
			},
			clear: {
				type: Boolean,
				default: true
			},
			defItem: {
				type: Number,
				default: 0
			}
		},
		// 下拉到底部后加载新数据
		onReachBottom() {
			console.log(2222222222222)
			//判断下一页是否存在数据，不存在将显示暂无数据等提示语
			// if (this.localdata.length >= this.pageIndex * 10) {
			// 	this.pageIndex++; //页数加一
			// 	this.init(); //回调接口
			// } else {
			// 	this.nomore = true
			// }
		
		},
		created() {
			this.last = `${this.collection}_last_selected_option_value`
			if (this.collection && !this.localdata.length) {
				this.mixinDatacomEasyGet()
			}
		},
		computed: {
			typePlaceholder() {
				const text = {
					'opendb-stat-app-versions': '版本',
					'opendb-app-channels': '渠道',
					'opendb-app-list': '应用'
				}
				const common = '请选择'
				const placeholder = text[this.collection]
				return placeholder ?
					common + placeholder :
					common
			}
		},
		watch: {
			localdata: {
				immediate: true,
				handler(val, old) {
					if (Array.isArray(val)) {
						this.mixinDatacomResData = val
					}
				}
			},
			// #ifndef VUE3
			value() {
				this.initDefVal()
			},
			// #endif
			// #ifdef VUE3
			modelValue() {
				this.initDefVal()
			},
			// #endif
			mixinDatacomResData: {
				immediate: true,
				handler(val) {
					if (val.length) {
						this.initDefVal()
					}
				}
			}
		},
		
		methods: {
			moveAdd(){
				uni.navigateTo({
					url:"/pages/alldeatil/addnewdrawer?add=1"
				})
			},
			initDefVal() {
				let defValue = ''
				if ((this.value || this.value === 0) && !this.isDisabled(this.value)) {
					defValue = this.value
				} else if ((this.modelValue || this.modelValue === 0) && !this.isDisabled(this.modelValue)) {
					defValue = this.modelValue
				} else {
					let strogeValue
					if (this.collection) {
						strogeValue = uni.getStorageSync(this.last)
					}
					if (strogeValue || strogeValue === 0) {
						defValue = strogeValue
					} else {
						let defItem = ''
						if (this.defItem > 0 && this.defItem < this.mixinDatacomResData.length) {
							defItem = this.mixinDatacomResData[this.defItem - 1].value
						}
						defValue = defItem
					}
					this.emit(defValue)
				}
				const def = this.mixinDatacomResData.find(item => item.value === defValue)
				this.current = def ? this.formatItemName(def) : ''
			},

			/**
			 * @param {[String, Number]} value
			 * 判断用户给的 value 是否同时为禁用状态
			 */
			isDisabled(value) {
				let isDisabled = false;

				this.mixinDatacomResData.forEach(item => {
					if (item.value === value) {
						isDisabled = item.disable
					}
				})

				return isDisabled;
			},
			selectChecked(){
				
			},
			clearVal() {
				// console.log(999999999)
				this.emit('clearall',111)
				// this.emit('')
				if (this.collection) {
					uni.removeStorageSync(this.last)
				}
			},
			seaarchInput() {
				this.emit('search',this.seachcontent)
			},
			change(item) {
			
				if (!item.disable) {
					this.showSelector = false
					this.current = this.formatItemName(item)
					this.emit(item.value)
				}
			},
			emit(val) {
				this.$emit('change', val)
				this.$emit('input', val)
				this.$emit('update:modelValue', val)
				if (this.collection) {
					uni.setStorageSync(this.last, val)
				}
			},

			toggleSelector() {
				this.showSelector = !this.showSelector
				this.$emit('checkin',this.checklistIn)
			},
			changeSeach(e){
				this.$emit('search',e.detail.value)
			},
			formatItemName(item) {
				
				let {
					text,
					value,
					channel_code
				} = item
				channel_code = channel_code ? `(${channel_code})` : ''
				return this.collection.indexOf('app-list') > 0 ?
					`${text}(${value})` :
					(
						text ?
						text :
						`未命名${channel_code}`
					)
			}
		}
	}
</script>

<style lang="scss">
	$uni-base-color: #6a6a6a !default;
	$uni-main-color: #3a3a3a !default;
	$uni-secondary-color: #909399 !default;
	$uni-border-3: #DCDCDC;


	/* #ifndef APP-NVUE */
	@media screen and (max-width: 500px) {
		.hide-on-phone {
			display: none;
		}
	}

	/* #endif */
	.uni-stat__select {
		display: flex;
		align-items: center;
		// padding: 15px;
		cursor: pointer;
	}

	.uni-label-text {
		font-size: 14px;
		font-weight: bold;
		color: $uni-base-color;
		margin: auto 0;
		margin-right: 5px;
	}
	.searchbox{
		display: flex;
		align-items: center;
		width: 630rpx;
		height: 75rpx;
		font-size: 28rpx;
		border-radius: 20rpx;
		background-color: #F8F8F8;
		border: 1rpx solid #D9D9D9;
		margin:40rpx auto;
		padding: 0 30rpx;
		box-sizing: border-box;
		margin-bottom: 20rpx;
		input{
			padding: 0;
			padding-left: 10rpx;
		}
	}
	.addplus{
		width: 630rpx;
		height: 68rpx;
		border-radius: 20rpx;
		border: 1rpx solid #D8AB5A;
		color: #D8AB5A;
		display: flex;
		align-items: center;
		justify-content: center;
		margin: 0 auto;
		margin-top: 40rpx;
		font-size: 35rpx;
	}
	.uni-select {
		font-size: 14px;
		border: 1px solid $uni-border-3;
		box-sizing: border-box;
		border-radius:10px;
		padding: 0 5px;
		position: relative;
		/* #ifndef APP-NVUE */
		display: flex;
		user-select: none;
		/* #endif */
		flex-direction: row;
		align-items: center;
		border-bottom: solid 1px $uni-border-3;
		width: 100%;
		height: 78rpx;
	}

	.uni-select__label {
		font-size: 16px;
		line-height: 22px;
		padding-right: 10px;
		// color: $uni-secondary-color;
	}

	.uni-select__input-box {
		min-height: 36px;
		position: relative;
		/* #ifndef APP-NVUE */
		display: flex;
		/* #endif */
		flex: 1;
		flex-direction: row;
		align-items: center;
		justify-content: space-between;
		padding-right:5px;
		box-sizing: border-box;
	}

	.uni-select__input {
		flex: 1;
		font-size: 14px;
		height: 22px;
		line-height: 22px;
	}

	.uni-select__input-plac {
		font-size: 14px;
		// color: $uni-secondary-color;
	}

	.uni-select__selector {
		/* #ifndef APP-NVUE */
		box-sizing: border-box;
		/* #endif */
		position: absolute;
		top: calc(100% + 12px);
		left: 0;
		width: 100%;
		background-color: #FFFFFF;
		border: 1px solid #EBEEF5;
		border-radius: 6px;
		box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
		z-index: 99;
		padding: 4px 0;
		margin-bottom: 40rpx;
		// bottom: 40rpx;
	}

	.uni-select__selector-scroll {
		/* #ifndef APP-NVUE */
		max-height: 340px;
		box-sizing: border-box;
		/* #endif */
	}

	.uni-select__selector-empty,
	.uni-select__selector-item {
		/* #ifndef APP-NVUE */
		display: flex;
		cursor: pointer;
		/* #endif */
		line-height: 36px;
		font-size: 14px;
		text-align: center;
		border-bottom: solid 1px $uni-border-3; 
		margin: 0px 15px;
		padding: 10rpx 0;
		font-size: 32rpx;
	}

	.uni-select__selector-item:hover {
		background-color: #f9f9f9;
	}

	.uni-select__selector-empty:last-child,
	.uni-select__selector-item:last-child {
		/* #ifndef APP-NVUE */
		border-bottom: none;
		/* #endif */
	}

	.uni-select__selector__disabled {
		opacity: 0.4;
		cursor: default;
	}

	/* picker 弹出层通用的指示小三角 */
	.uni-popper__arrow,
	.uni-popper__arrow::after {
		position: absolute;
		display: block;
		width: 0;
		height: 0;
		border-color: transparent;
		border-style: solid;
		border-width: 6px;
	}

	.uni-popper__arrow {
		filter: drop-shadow(0 2px 12px rgba(0, 0, 0, 0.03));
		top: -6px;
		left: 10%;
		margin-right: 3px;
		border-top-width: 0;
		border-bottom-color: #EBEEF5;
	}

	.uni-popper__arrow::after {
		content: " ";
		top: 1px;
		margin-left: -6px;
		border-top-width: 0;
		border-bottom-color: #fff;
	}

	.uni-select__input-text {
		width: 280px;
		color: $uni-main-color;
		white-space: nowrap;
		text-overflow: ellipsis;
		-o-text-overflow: ellipsis;
		overflow: hidden;
		padding:0 15rpx;
	}

	.uni-select__input-placeholder {
		color: #BEBDBB;
		font-size: 30rpx;
		padding: 15rpx 15rpx;
	}

	.uni-select--mask {
		position: fixed;
		top: 0;
		bottom: 0;
		right: 0;
		left: 0;
	}
</style>
